#include <hxcpp.h>

#ifndef INCLUDED_snow_platform_native_input_sdl_MouseEventType
#include <snow/platform/native/input/sdl/MouseEventType.h>
#endif
#ifndef INCLUDED_snow_platform_native_input_sdl_MouseEventTypes
#include <snow/platform/native/input/sdl/MouseEventTypes.h>
#endif
namespace snow{
namespace platform{
namespace native{
namespace input{
namespace sdl{

Void MouseEventTypes_obj::__construct()
{
	return null();
}

//MouseEventTypes_obj::~MouseEventTypes_obj() { }

Dynamic MouseEventTypes_obj::__CreateEmpty() { return  new MouseEventTypes_obj; }
hx::ObjectPtr< MouseEventTypes_obj > MouseEventTypes_obj::__new()
{  hx::ObjectPtr< MouseEventTypes_obj > result = new MouseEventTypes_obj();
	result->__construct();
	return result;}

Dynamic MouseEventTypes_obj::__Create(hx::DynamicArray inArgs)
{  hx::ObjectPtr< MouseEventTypes_obj > result = new MouseEventTypes_obj();
	result->__construct();
	return result;}

int MouseEventTypes_obj::me_move;

int MouseEventTypes_obj::me_down;

int MouseEventTypes_obj::me_up;

int MouseEventTypes_obj::me_wheel;

::snow::platform::native::input::sdl::MouseEventType MouseEventTypes_obj::typed( int me_type){
	HX_STACK_FRAME("snow.platform.native.input.sdl.MouseEventTypes","typed",0x53b6f522,"snow.platform.native.input.sdl.MouseEventTypes.typed","snow/platform/native/input/sdl/InputSystem.hx",400,0x01aafc86)
	HX_STACK_ARG(me_type,"me_type")
	HX_STACK_LINE(402)
	if (((me_type == ::snow::platform::native::input::sdl::MouseEventTypes_obj::me_move))){
		HX_STACK_LINE(402)
		return ::snow::platform::native::input::sdl::MouseEventType_obj::move;
	}
	HX_STACK_LINE(403)
	if (((me_type == ::snow::platform::native::input::sdl::MouseEventTypes_obj::me_down))){
		HX_STACK_LINE(403)
		return ::snow::platform::native::input::sdl::MouseEventType_obj::down;
	}
	HX_STACK_LINE(404)
	if (((me_type == ::snow::platform::native::input::sdl::MouseEventTypes_obj::me_up))){
		HX_STACK_LINE(404)
		return ::snow::platform::native::input::sdl::MouseEventType_obj::up;
	}
	HX_STACK_LINE(405)
	if (((me_type == ::snow::platform::native::input::sdl::MouseEventTypes_obj::me_wheel))){
		HX_STACK_LINE(405)
		return ::snow::platform::native::input::sdl::MouseEventType_obj::wheel;
	}
	HX_STACK_LINE(407)
	return ::snow::platform::native::input::sdl::MouseEventType_obj::unknown;
}


STATIC_HX_DEFINE_DYNAMIC_FUNC1(MouseEventTypes_obj,typed,return )


MouseEventTypes_obj::MouseEventTypes_obj()
{
}

Dynamic MouseEventTypes_obj::__Field(const ::String &inName,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"me_up") ) { return me_up; }
		if (HX_FIELD_EQ(inName,"typed") ) { return typed_dyn(); }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"me_move") ) { return me_move; }
		if (HX_FIELD_EQ(inName,"me_down") ) { return me_down; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"me_wheel") ) { return me_wheel; }
	}
	return super::__Field(inName,inCallProp);
}

Dynamic MouseEventTypes_obj::__SetField(const ::String &inName,const Dynamic &inValue,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"me_up") ) { me_up=inValue.Cast< int >(); return inValue; }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"me_move") ) { me_move=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"me_down") ) { me_down=inValue.Cast< int >(); return inValue; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"me_wheel") ) { me_wheel=inValue.Cast< int >(); return inValue; }
	}
	return super::__SetField(inName,inValue,inCallProp);
}

void MouseEventTypes_obj::__GetFields(Array< ::String> &outFields)
{
	super::__GetFields(outFields);
};

static ::String sStaticFields[] = {
	HX_CSTRING("me_move"),
	HX_CSTRING("me_down"),
	HX_CSTRING("me_up"),
	HX_CSTRING("me_wheel"),
	HX_CSTRING("typed"),
	String(null()) };

#if HXCPP_SCRIPTABLE
static hx::StorageInfo *sMemberStorageInfo = 0;
#endif

static ::String sMemberFields[] = {
	String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(MouseEventTypes_obj::__mClass,"__mClass");
	HX_MARK_MEMBER_NAME(MouseEventTypes_obj::me_move,"me_move");
	HX_MARK_MEMBER_NAME(MouseEventTypes_obj::me_down,"me_down");
	HX_MARK_MEMBER_NAME(MouseEventTypes_obj::me_up,"me_up");
	HX_MARK_MEMBER_NAME(MouseEventTypes_obj::me_wheel,"me_wheel");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatics(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(MouseEventTypes_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(MouseEventTypes_obj::me_move,"me_move");
	HX_VISIT_MEMBER_NAME(MouseEventTypes_obj::me_down,"me_down");
	HX_VISIT_MEMBER_NAME(MouseEventTypes_obj::me_up,"me_up");
	HX_VISIT_MEMBER_NAME(MouseEventTypes_obj::me_wheel,"me_wheel");
};

#endif

Class MouseEventTypes_obj::__mClass;

void MouseEventTypes_obj::__register()
{
	hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.platform.native.input.sdl.MouseEventTypes"), hx::TCanCast< MouseEventTypes_obj> ,sStaticFields,sMemberFields,
	&__CreateEmpty, &__Create,
	&super::__SGetClass(), 0, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatics
#endif
#ifdef HXCPP_SCRIPTABLE
    , sMemberStorageInfo
#endif
);
}

void MouseEventTypes_obj::__boot()
{
	me_move= (int)1024;
	me_down= (int)1025;
	me_up= (int)1026;
	me_wheel= (int)1027;
}

} // end namespace snow
} // end namespace platform
} // end namespace native
} // end namespace input
} // end namespace sdl
